<TeXmacs|1.0.2.9>

<style|mmxdoc>

<\body>
  <tmdoc-title|Interpretation versus compilation>

  In order to have a prototype of the <value|mmx> language in a reasonable
  amount of time, it is important to be able to write an interpreter first.
  Depending on the language, it can be more or less hard to do this.

  For instance, when the language allows for overloading, like <name|Aldor>
  does, then one needs an on-the-fly mechanism for typing ambiguous
  expressions. This can either be done by requiring each function application
  to be disambiguous, or by allowing for ambiguous values. In several cases,
  we found the first approach to be unsatisfactory (literals integer values
  are naturally ambiguous, access functions to a table are naturally
  ambiguous in <value|mmx> (read-only or read-write access), <abbr|etc.>).
  The second approach has the disadvantage that one might have to propagate
  disambiguities and thereby delay the actual evaluation. Nevertheless, in
  <value|mmx>, this could easily be done using continuations. However, the
  user should be aware of these potential changes in the order of evaluation.

  Another problem is that certain type information can be expensive to obtain
  (find the right method in a heavily overloaded function) and very context
  sensitive (the <verbatim|import> primitive in <name|Aldor>). In <value|mmx>
  this problem is solved by (implemented in a global way) caching type
  resolutions and (not implemented) propagating this information to the
  outermost scope where it remains valid.

  <tmdoc-copyright|2003|Joris van der Hoeven>

  <tmdoc-license|Permission is granted to copy, distribute and/or modify this
  document under the terms of the <hlink|GNU General Public
  License|http://www.gnu.org/licenses/gpl.txt>. If you don't have this file,
  write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.>
</body>

<\initial>
  <\collection>
    <associate|page-even|30mm>
    <associate|page-reduce-bot|15mm>
    <associate|page-reduce-right|25mm>
    <associate|page-reduce-left|25mm>
    <associate|page-top|30mm>
    <associate|page-right|30mm>
    <associate|par-width|150mm>
    <associate|page-odd|30mm>
    <associate|page-bot|30mm>
    <associate|page-reduce-top|15mm>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|abuse-conv|<tuple|1|?>>
    <associate|toc-1|<tuple|<uninit>|?>>
    <associate|toc-2|<tuple|<uninit>|?>>
    <associate|toc-3|<tuple|<uninit>|?>>
    <associate|toc-4|<tuple|<uninit>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|toc>
      <with|par-left|<quote|6fn>|font-size|<quote|0.84>|Logical
      supertypes<value|toc-dots><pageref|toc-1>>

      <with|par-left|<quote|6fn>|font-size|<quote|0.84>|Extensibility and
      exceptions<value|toc-dots><pageref|toc-2>>

      <with|par-left|<quote|6fn>|font-size|<quote|0.84>|Feasability<value|toc-dots><pageref|toc-3>>

      <with|par-left|<quote|6fn>|font-size|<quote|0.84>|Semantics<value|toc-dots><pageref|toc-4>>
    </associate>
  </collection>
</auxiliary>