
/******************************************************************************
* MODULE     : alias.hh
* DESCRIPTION: Aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __ALIAS_HH
#define __ALIAS_HH
#include <genalias.hh>
namespace mmx {

class alias;
class alias_rep: public genalias_rep {
protected:
  generic& ref;
  int Type ();

public:
  inline alias_rep (generic& g): ref (g) {}
  inline generic get () { return ref; }
  inline void set (generic val) { ref= val; }

  friend class alias;
};

class alias {
protected:
  alias_rep* rep;
  inline alias (alias_rep* rep2): rep (rep2) {}

public:
  inline alias (generic& g):
    rep (new alias_rep (g)) {}
  inline friend alias as_alias (generic g) {
    if (gentype(g) != ALIAS_TYPE) type_mismatch (g, "alias");
    return alias ((alias_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline alias_rep* operator -> () { return rep; }

  friend class alias_rep;
};

}
#endif // __ALIAS_HH
