
/******************************************************************************
* MODULE     : serializer.cc
* DESCRIPTION: serializers
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <serializer.hh>
#include <symbol.hh>
namespace mmx {

/******************************************************************************
* Required routines for generic structures
******************************************************************************/

int
serializer_rep::Type () {
  return SERIALIZER_TYPE;
}

void
serializer_rep::Print (ostream& out) {
  out << serializer (this);
}

/******************************************************************************
* Routines for serializers
******************************************************************************/

ostream&
operator << (ostream& out, serializer ser) {
  return out << as_string (ser);
}

string
as_string (serializer ser) {
  if (ser->out.pcount () == 0) return "";
  else return string (ser->out.str(), ser->out.pcount ());
}

printer
as_printer (serializer ser) {
  return printer (symbol ("string"), ser->out);
}

} // namespace mmx
