
/******************************************************************************
* MODULE     : serializer.hh
* DESCRIPTION: mathemagix output streams
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SERIALIZER_HH
#define __SERIALIZER_HH
#include <strstream>
#include <string.hh>
#include <printer.hh>
using std::ostrstream;
namespace mmx {

class serializer;
class serializer_rep: generic_rep {
public:
  ostrstream out;

protected:
  int Type ();
  void Print (ostream& out);

public:
  inline serializer_rep () {}

  friend class serializer;
  friend serializer copy (serializer t);
  friend ostream& operator << (ostream& out, serializer a);
};

class serializer {
protected:
  serializer_rep* rep;
  inline serializer (serializer_rep* rep2): rep (rep2) {}

public:
  inline serializer ():
    rep (new serializer_rep ()) {}
  inline friend serializer as_serializer (generic g) {
    if (gentype(g) != SERIALIZER_TYPE) type_mismatch (g, "serializer");
    return serializer ((serializer_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline serializer_rep* operator -> () { return rep; }
  friend ostream& operator << (ostream& out, serializer a);

  friend class serializer_rep;
};

string as_string (serializer ser);
printer as_printer (serializer ser);

}
#endif // __SERIALIZER_HH
